From 73ba1f5a755a640f67fe15acd195d0cb3541f893 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Hugo=20Beauz=C3=A9e-Luyssen?= <beauze.h@gmail.com>
Date: Sun, 4 Mar 2012 20:47:47 +0100
Subject: [PATCH 10/10] bluray: Cosmetics

---
 modules/access/bluray.c |  809 ++++++++++++++++++++++-------------------------
 1 file changed, 380 insertions(+), 429 deletions(-)

diff --git a/modules/access/bluray.c b/modules/access/bluray.c
index 1af804d..96a78ff 100644
--- a/modules/access/bluray.c
+++ b/modules/access/bluray.c
@@ -4,6 +4,7 @@
  * Copyright © 2010-2011 VideoLAN, VLC authors and libbluray AUTHORS
  *
  * Authors: Jean-Baptiste Kempf <jb@videolan.org>
+ *          Hugo Beauze-Luyssen <beauze.h@gmail.com>
  *
  * This program is free software; you can redistribute it and/or modify it
  * under the terms of the GNU Lesser General Public License as published by
@@ -56,32 +57,30 @@ static int  blurayOpen ( vlc_object_t * );
 static void blurayClose( vlc_object_t * );
 
 vlc_module_begin ()
-    set_shortname( N_("BluRay") )
-    set_description( N_("Blu-Ray Disc support (libbluray)") )
+set_shortname( N_("BluRay") )
+set_description( N_("Blu-Ray Disc support (libbluray)") )
 
-    set_category( CAT_INPUT )
-    set_subcategory( SUBCAT_INPUT_ACCESS )
-    set_capability( "access_demux", 200)
-    add_bool( "bluray-menu", false, BD_MENU_TEXT, BD_MENU_LONGTEXT, false )
+set_category( CAT_INPUT )
+set_subcategory( SUBCAT_INPUT_ACCESS )
+set_capability( "access_demux", 200)
+add_bool( "bluray-menu", false, BD_MENU_TEXT, BD_MENU_LONGTEXT, false )
 
-    add_shortcut( "bluray", "file" )
+add_shortcut( "bluray", "file" )
 
-    set_callbacks( blurayOpen, blurayClose )
+set_callbacks( blurayOpen, blurayClose )
 vlc_module_end ()
 
 /* libbluray's overlay.h defines 2 types of overlay (bd_overlay_plane_e). */
 #define MAX_OVERLAY 2
 
-typedef enum    OverlayStatus
-{
+typedef enum    OverlayStatus {
     Closed = 0,
     ToDisplay,  //Used to mark the overlay to be displayed the first time.
     Displayed,
     Outdated    //used to update the overlay after it has been sent to the vout
 }               OverlayStatus;
 
-typedef struct bluray_overlay_t
-{
+typedef struct bluray_overlay_t {
     VLC_GC_MEMBERS
 
     vlc_mutex_t             lock;
@@ -90,8 +89,7 @@ typedef struct bluray_overlay_t
     subpicture_region_t     *p_regions;
 }   bluray_overlay_t;
 
-struct  demux_sys_t
-{
+struct  demux_sys_t {
     BLURAY              *bluray;
 
     /* Titles */
@@ -115,241 +113,26 @@ struct  demux_sys_t
     stream_t            *p_parser;
 };
 
-struct subpicture_updater_sys_t
-{
+struct subpicture_updater_sys_t {
     bluray_overlay_t    *p_overlay;
 };
 
-/*****************************************************************************
- * Local prototypes
- *****************************************************************************/
-static int     blurayControl(demux_t *, int, va_list);
-static int     blurayDemux(demux_t *);
-
-static int     blurayInitTitles(demux_t *p_demux );
-static int     bluraySetTitle(demux_t *p_demux, int i_title);
-
-static void    blurayOverlayProc( void *ptr, const BD_OVERLAY * const overlay );
-
-static int     onMouseEvent( vlc_object_t *p_vout, const char *psz_var,
-                             vlc_value_t old, vlc_value_t val, void *p_data );
-
 #define FROM_TICKS(a) (a*CLOCK_FREQ / INT64_C(90000))
 #define TO_TICKS(a)   (a*INT64_C(90000)/CLOCK_FREQ)
 #define CUR_LENGTH    p_sys->pp_title[p_demux->info.i_title]->i_length
 
 /*****************************************************************************
- * blurayOpen: module init function
- *****************************************************************************/
-static int blurayOpen( vlc_object_t *object )
-{
-    demux_t *p_demux = (demux_t*)object;
-    demux_sys_t *p_sys;
-
-    char *pos_title;
-    int i_title = -1;
-    char bd_path[PATH_MAX] = { '\0' };
-    const char *error_msg = NULL;
-
-    if (strcmp(p_demux->psz_access, "bluray")) {
-        // TODO BDMV support, once we figure out what to do in libbluray
-        return VLC_EGENERIC;
-    }
-
-    /* */
-    p_demux->p_sys = p_sys = calloc( 1, sizeof(*p_sys) );
-    if (unlikely(!p_sys)) {
-        return VLC_ENOMEM;
-    }
-    p_sys->current_overlay = -1;
-
-    /* init demux info fields */
-    p_demux->info.i_update    = 0;
-    p_demux->info.i_title     = 0;
-    p_demux->info.i_seekpoint = 0;
-
-    TAB_INIT( p_sys->i_title, p_sys->pp_title );
-
-    /* store current bd_path */
-    if (p_demux->psz_file) {
-        strncpy(bd_path, p_demux->psz_file, sizeof(bd_path));
-        bd_path[PATH_MAX - 1] = '\0';
-    }
-
-#if defined (HAVE_MNTENT_H) && defined (HAVE_SYS_STAT_H)
-    /* If we're passed a block device, try to convert it to the mount point. */
-    struct stat st;
-    if ( !stat (bd_path, &st)) {
-        if (S_ISBLK (st.st_mode)) {
-            FILE* mtab = setmntent ("/proc/self/mounts", "r");
-            struct mntent* m;
-            struct mntent mbuf;
-            char buf [8192];
-            while ((m = getmntent_r (mtab, &mbuf, buf, sizeof(buf))) != NULL) {
-                if (!strcmp (m->mnt_fsname, bd_path)) {
-                    strncpy (bd_path, m->mnt_dir, sizeof(bd_path));
-                    bd_path[sizeof(bd_path) - 1] = '\0';
-                    break;
-                }
-            }
-            endmntent (mtab);
-        }
-    }
-#endif /* HAVE_MNTENT_H && HAVE_SYS_STAT_H */
-    p_sys->bluray = bd_open(bd_path, NULL);
-    if (!p_sys->bluray) {
-        free(p_sys);
-        return VLC_EGENERIC;
-    }
-
-    /* Warning the user about AACS/BD+ */
-    const BLURAY_DISC_INFO *disc_info = bd_get_disc_info(p_sys->bluray);
-    if ( disc_info->bluray_detected == 0 )
-    {
-        error_msg = "Path doesn't appear to be a bluray";
-        goto error;
-    }
-    msg_Info(p_demux, "First play: %i, Top menu: %i\n"
-                      "HDMV Titles: %i, BD-J Titles: %i, Other: %i",
-             disc_info->first_play_supported, disc_info->top_menu_supported,
-             disc_info->num_hdmv_titles, disc_info->num_bdj_titles,
-             disc_info->num_unsupported_titles);
-
-    /* AACS */
-    if (disc_info->aacs_detected) {
-        if (!disc_info->libaacs_detected) {
-            error_msg = _("This Blu-Ray Disc needs a library for AACS decoding, "
-                      "and your system does not have it.");
-            goto error;
-        }
-        if (!disc_info->aacs_handled) {
-            error_msg = _("Your system AACS decoding library does not work. "
-                      "Missing keys?");
-            goto error;
-        }
-    }
-
-    /* BD+ */
-    if (disc_info->bdplus_detected) {
-        if (!disc_info->libbdplus_detected) {
-            error_msg = _("This Blu-Ray Disc needs a library for BD+ decoding, "
-                      "and your system does not have it.");
-            goto error;
-        }
-        if (!disc_info->bdplus_handled) {
-            error_msg = _("Your system BD+ decoding library does not work. "
-                      "Missing configuration?");
-            goto error;
-        }
-    }
-
-    /* Get titles and chapters */
-    p_sys->p_meta = bd_get_meta( p_sys->bluray );
-    if( p_sys->p_meta == NULL )
-        goto error;
-
-    if (blurayInitTitles(p_demux) != VLC_SUCCESS) {
-        goto error;
-    }
-
-    /*
-     * Initialize the event queue, so we can receive then in blurayDemux(Menu) later.
-     */
-    bd_get_event( p_sys->bluray, NULL );
-
-    p_sys->b_menu = var_InheritBool( p_demux, "bluray-menu" );
-    if ( p_sys->b_menu )
-    {
-        p_sys->p_input = demux_GetParentInput( p_demux );
-        if ( unlikely( p_sys->p_input == NULL ) )
-            goto error;
-        /*
-         * libbluray will start playback from "First-Title" title
-         * Therefore, We don't have to select any title.
-         */
-        bd_play( p_sys->bluray );
-        /* Registering overlay event handler */
-        bd_register_overlay_proc( p_sys->bluray, p_demux, blurayOverlayProc );
-    }
-    else
-    {
-        /* get title request */
-        if ((pos_title = strrchr(bd_path, ':'))) {
-            /* found character ':' for title information */
-            *(pos_title++) = '\0';
-            i_title = atoi(pos_title);
-        }
-
-        /* set start title number */
-        if (bluraySetTitle(p_demux, i_title) != VLC_SUCCESS) {
-            msg_Err( p_demux, "Could not set the title %d", i_title );
-            goto error;
-        }
-    }
-
-    p_sys->p_parser   = stream_DemuxNew(p_demux, "ts", p_demux->out);
-    if (!p_sys->p_parser) {
-        msg_Err(p_demux, "Failed to create TS demuxer");
-        goto error;
-    }
-
-    p_demux->pf_control = blurayControl;
-    p_demux->pf_demux   = blurayDemux;
-
-    return VLC_SUCCESS;
-
-error:
-    if (error_msg)
-        dialog_Fatal(p_demux, _("Blu-Ray error"), "%s", error_msg);
-    blurayClose(object);
-    return VLC_EGENERIC;
-}
-
-
-/*****************************************************************************
- * blurayClose: module destroy function
- *****************************************************************************/
-static void blurayClose( vlc_object_t *object )
-{
-    demux_t *p_demux = (demux_t*)object;
-    demux_sys_t *p_sys = p_demux->p_sys;
-
-    /*
-     * Close libbluray first. This will close all the overlays before we release p_vout
-     *
-     * bd_close( NULL ) can crash
-     */
-    assert(p_sys->bluray);
-    bd_close(p_sys->bluray);
-
-    if ( p_sys->p_vout != NULL )
-    {
-        var_DelCallback( p_sys->p_vout, "mouse-moved", &onMouseEvent, p_demux );
-        var_DelCallback( p_sys->p_vout, "mouse-clicked", &onMouseEvent, p_demux );
-        vlc_object_release( p_sys->p_vout );
-    }
-    if ( p_sys->p_input != NULL )
-        vlc_object_release( p_sys->p_input );
-    if (p_sys->p_parser)
-        stream_Delete(p_sys->p_parser);
-    /* Titles */
-    for (unsigned int i = 0; i < p_sys->i_title; i++)
-        vlc_input_title_Delete(p_sys->pp_title[i]);
-    TAB_CLEAN( p_sys->i_title, p_sys->pp_title );
-
-    free(p_sys);
-}
-
-/*****************************************************************************
  * subpicture_updater_t functions:
  *****************************************************************************/
 static int      subpictureUpdaterValidate( subpicture_t *p_subpic,
-                                           bool b_fmt_src, const video_format_t *p_fmt_src,
-                                           bool b_fmt_dst, const video_format_t *p_fmt_dst,
-                                           mtime_t i_ts )
+        bool b_fmt_src, const video_format_t *p_fmt_src,
+        bool b_fmt_dst, const video_format_t *p_fmt_dst,
+        mtime_t i_ts )
 {
-    VLC_UNUSED( b_fmt_src ); VLC_UNUSED( b_fmt_dst );
-    VLC_UNUSED( p_fmt_src ); VLC_UNUSED( p_fmt_dst );
+    VLC_UNUSED( b_fmt_src );
+    VLC_UNUSED( b_fmt_dst );
+    VLC_UNUSED( p_fmt_src );
+    VLC_UNUSED( p_fmt_dst );
     VLC_UNUSED( i_ts );
     subpicture_updater_sys_t    *p_upd_sys = p_subpic->updater.p_sys;
     bluray_overlay_t            *p_overlay = p_upd_sys->p_overlay;
@@ -375,11 +158,10 @@ static subpicture_region_t*     subpicture_region_Clone( subpicture_region_t *p_
 
     p_region_dst->psz_text = p_region_src->psz_text ? strdup( p_region_src->psz_text ) : NULL;
     p_region_dst->psz_html = p_region_src->psz_html ? strdup( p_region_src->psz_html ) : NULL;
-    if ( p_region_src->p_style != NULL )
-    {
+    if ( p_region_src->p_style != NULL ) {
         p_region_dst->p_style = malloc( sizeof( *p_region_dst->p_style ) );
         p_region_dst->p_style = text_style_Copy( p_region_dst->p_style,
-                                                 p_region_src->p_style );
+                                p_region_src->p_style );
     }
 
     //Palette is already copied by subpicture_region_New, we just have to duplicate p_pixels
@@ -391,11 +173,13 @@ static subpicture_region_t*     subpicture_region_Clone( subpicture_region_t *p_
 }
 
 static void     subpictureUpdaterUpdate( subpicture_t *p_subpic,
-                              const video_format_t *p_fmt_src,
-                              const video_format_t *p_fmt_dst,
-                              mtime_t i_ts )
+        const video_format_t *p_fmt_src,
+        const video_format_t *p_fmt_dst,
+        mtime_t i_ts )
 {
-    VLC_UNUSED( p_fmt_src ); VLC_UNUSED( p_fmt_dst ); VLC_UNUSED( i_ts );
+    VLC_UNUSED( p_fmt_src );
+    VLC_UNUSED( p_fmt_dst );
+    VLC_UNUSED( i_ts );
     subpicture_updater_sys_t    *p_upd_sys = p_subpic->updater.p_sys;
     bluray_overlay_t            *p_overlay = p_upd_sys->p_overlay;
 
@@ -410,8 +194,7 @@ static void     subpictureUpdaterUpdate( subpicture_t *p_subpic,
         return ;
 
     subpicture_region_t **p_dst = &(p_subpic->p_region);
-    while ( p_src != NULL )
-    {
+    while ( p_src != NULL ) {
         *p_dst = subpicture_region_Clone( p_src );
         if ( *p_dst == NULL )
             break ;
@@ -443,13 +226,10 @@ static int  onMouseEvent( vlc_object_t *p_vout, const char *psz_var, vlc_value_t
 
     if ( psz_var[6] == 'm' ) //Mouse moved
         bd_mouse_select( p_sys->bluray, now, val.coords.x, val.coords.y );
-    else if ( psz_var[6] == 'c' )
-    {
+    else if ( psz_var[6] == 'c' ) {
         bd_mouse_select( p_sys->bluray, now, val.coords.x, val.coords.y );
         bd_user_input( p_sys->bluray, now, BD_VK_MOUSE_ACTIVATE );
-    }
-    else
-    {
+    } else {
         assert(0);
     }
     return VLC_SUCCESS;
@@ -476,12 +256,9 @@ static void blurayCloseAllOverlays( demux_t *p_demux )
     demux_sys_t     *p_sys = p_demux->p_sys;
 
     p_demux->p_sys->current_overlay = -1;
-    if ( p_sys->p_vout != NULL )
-    {
-        for ( int i = 0; i < 0; i++ )
-        {
-            if ( p_sys->p_overlays[i] != NULL )
-            {
+    if ( p_sys->p_vout != NULL ) {
+        for ( int i = 0; i < 0; i++ ) {
+            if ( p_sys->p_overlays[i] != NULL ) {
                 vout_FlushSubpictureChannel( p_sys->p_vout,
                                              p_sys->p_overlays[i]->p_pic->i_channel );
                 vlc_gc_decref( p_sys->p_overlays[i] );
@@ -512,9 +289,8 @@ static void blurayActivateOverlay( demux_t *p_demux, const BD_OVERLAY* const ov
      */
     vlc_mutex_lock( &p_sys->p_overlays[ov->plane]->lock );
     if ( ( p_sys->p_overlays[ov->plane]->status == Displayed ||
-           p_sys->p_overlays[ov->plane]->status == Outdated )
-         && p_sys->p_vout )
-    {
+            p_sys->p_overlays[ov->plane]->status == Outdated )
+            && p_sys->p_vout ) {
         p_sys->p_overlays[ov->plane]->status = Outdated;
         vlc_mutex_unlock( &p_sys->p_overlays[ov->plane]->lock );
         return ;
@@ -539,8 +315,7 @@ static void blurayInitOverlay( demux_t *p_demux, const BD_OVERLAY* const ov )
     if ( unlikely( p_sys->p_overlays[ov->plane] == NULL ) )
         return ;
     subpicture_updater_sys_t    *p_upd_sys = malloc( sizeof( *p_upd_sys ) );
-    if ( unlikely( p_upd_sys == NULL ) )
-    {
+    if ( unlikely( p_upd_sys == NULL ) ) {
         free( p_sys->p_overlays[ov->plane] );
         p_sys->p_overlays[ov->plane] = NULL;
         return ;
@@ -550,8 +325,7 @@ static void blurayInitOverlay( demux_t *p_demux, const BD_OVERLAY* const ov )
     vlc_gc_incref( p_sys->p_overlays[ov->plane] );
 
     p_upd_sys->p_overlay = p_sys->p_overlays[ov->plane];
-    subpicture_updater_t    updater =
-    {
+    subpicture_updater_t    updater = {
         .pf_validate = subpictureUpdaterValidate,
         .pf_update = subpictureUpdaterUpdate,
         .pf_destroy = subpictureUpdaterDestroy,
@@ -604,17 +378,15 @@ static void blurayDrawOverlay( demux_t *p_demux, const BD_OVERLAY* const ov )
     /* Find a region to update */
     subpicture_region_t *p_reg = p_sys->p_overlays[ov->plane]->p_regions;
     subpicture_region_t *p_last = NULL;
-    while ( p_reg != NULL )
-    {
+    while ( p_reg != NULL ) {
         p_last = p_reg;
         if ( p_reg->i_x == ov->x && p_reg->i_y == ov->y &&
-             p_reg->fmt.i_width == ov->w && p_reg->fmt.i_height == ov->h )
+                p_reg->fmt.i_width == ov->w && p_reg->fmt.i_height == ov->h )
             break ;
         p_reg = p_reg->p_next;
     }
     /* If there is no region to update, create a new one. */
-    if ( p_reg == NULL )
-    {
+    if ( p_reg == NULL ) {
         video_format_t          fmt;
         video_format_Init( &fmt, 0 );
         video_format_Setup( &fmt, VLC_CODEC_YUVP, ov->w, ov->h, 1, 1 );
@@ -631,10 +403,8 @@ static void blurayDrawOverlay( demux_t *p_demux, const BD_OVERLAY* const ov )
 
     /* Now we can update the region, regardless it's an update or an insert */
     const BD_PG_RLE_ELEM    *img = ov->img;
-    for ( int y = 0; y < ov->h; y++ )
-    {
-        for ( int x = 0; x < ov->w; )
-        {
+    for ( int y = 0; y < ov->h; y++ ) {
+        for ( int x = 0; x < ov->w; ) {
             memset( p_reg->p_picture->p[0].p_pixels +
                     y * p_reg->p_picture->p[0].i_pitch + x,
                     img->color, img->len );
@@ -642,11 +412,9 @@ static void blurayDrawOverlay( demux_t *p_demux, const BD_OVERLAY* const ov )
             img++;
         }
     }
-    if ( ov->palette )
-    {
+    if ( ov->palette ) {
         p_reg->fmt.p_palette->i_entries = 256;
-        for ( int i = 0; i < 256; ++i )
-        {
+        for ( int i = 0; i < 256; ++i ) {
             p_reg->fmt.p_palette->palette[i][0] = ov->palette[i].Y;
             p_reg->fmt.p_palette->palette[i][1] = ov->palette[i].Cb;
             p_reg->fmt.p_palette->palette[i][2] = ov->palette[i].Cr;
@@ -663,30 +431,28 @@ static void blurayOverlayProc( void *ptr, const BD_OVERLAY *const overlay )
 {
     demux_t     *p_demux = (demux_t*)ptr;
 
-    if ( overlay == NULL )
-    {
+    if ( overlay == NULL ) {
         msg_Info( p_demux, "Closing overlay." );
         blurayCloseAllOverlays( p_demux );
         return ;
     }
-    switch ( overlay->cmd )
-    {
-        case BD_OVERLAY_INIT:
-            msg_Info( p_demux, "Initializing overlay" );
-            blurayInitOverlay( p_demux, overlay );
-            break ;
-        case BD_OVERLAY_CLEAR:
-            blurayClearOverlay( p_demux, overlay );
-            break ;
-        case BD_OVERLAY_FLUSH:
-            blurayActivateOverlay( p_demux, overlay );
-            break ;
-        case BD_OVERLAY_DRAW:
-            blurayDrawOverlay( p_demux, overlay );
-            break ;
-        default:
-            msg_Warn( p_demux, "Unknown BD overlay command: %u", overlay->cmd );
-            break ;
+    switch ( overlay->cmd ) {
+    case BD_OVERLAY_INIT:
+        msg_Info( p_demux, "Initializing overlay" );
+        blurayInitOverlay( p_demux, overlay );
+        break ;
+    case BD_OVERLAY_CLEAR:
+        blurayClearOverlay( p_demux, overlay );
+        break ;
+    case BD_OVERLAY_FLUSH:
+        blurayActivateOverlay( p_demux, overlay );
+        break ;
+    case BD_OVERLAY_DRAW:
+        blurayDrawOverlay( p_demux, overlay );
+        break ;
+    default:
+        msg_Warn( p_demux, "Unknown BD overlay command: %u", overlay->cmd );
+        break ;
     }
 }
 
@@ -699,9 +465,9 @@ static void bluraySendOverlayToVout( demux_t *p_demux )
             p_sys->p_overlays[p_sys->current_overlay]->p_pic != NULL );
 
     p_sys->p_overlays[p_sys->current_overlay]->p_pic->i_start =
-            p_sys->p_overlays[p_sys->current_overlay]->p_pic->i_stop = mdate();
+        p_sys->p_overlays[p_sys->current_overlay]->p_pic->i_stop = mdate();
     p_sys->p_overlays[p_sys->current_overlay]->p_pic->i_channel =
-            vout_RegisterSubpictureChannel( p_sys->p_vout );
+        vout_RegisterSubpictureChannel( p_sys->p_vout );
     /*
      * After this point, the picture should not be accessed from the demux thread,
      * as it's hold by the vout thread.
@@ -716,6 +482,10 @@ static void bluraySendOverlayToVout( demux_t *p_demux )
     p_sys->p_overlays[p_sys->current_overlay]->status = Outdated;
 }
 
+/*****************************************************************************
+ * Titles management:
+ *****************************************************************************/
+
 static int blurayInitTitles(demux_t *p_demux )
 {
     demux_sys_t *p_sys = p_demux->p_sys;
@@ -787,8 +557,7 @@ static void blurayResetParser( demux_t *p_demux )
 static void blurayUpdateTitle( demux_t *p_demux, int i_title )
 {
     blurayResetParser( p_demux );
-    if ( i_title >= p_demux->p_sys->i_title )
-    {
+    if ( i_title >= p_demux->p_sys->i_title ) {
         if ( i_title == BLURAY_TITLE_FIRST_PLAY )
             i_title = p_demux->p_sys->i_first_play;
         else if ( i_title == BLURAY_TITLE_TOP_MENU )
@@ -838,146 +607,134 @@ static int blurayControl(demux_t *p_demux, int query, va_list args)
     int64_t  *pi_64;
 
     switch (query) {
-        case DEMUX_CAN_SEEK:
-        case DEMUX_CAN_PAUSE:
-        case DEMUX_CAN_CONTROL_PACE:
-             pb_bool = (bool*)va_arg( args, bool * );
-             *pb_bool = true;
-             break;
-
-        case DEMUX_GET_PTS_DELAY:
-            pi_64 = (int64_t*)va_arg( args, int64_t * );
-            *pi_64 =
-                INT64_C(1000) * var_InheritInteger( p_demux, "disc-caching" );
-            break;
-
-        case DEMUX_SET_PAUSE_STATE:
-            /* Nothing to do */
-            break;
-
-        case DEMUX_SET_TITLE:
-        {
-            int i_title = (int)va_arg( args, int );
-            if (bluraySetTitle(p_demux, i_title) != VLC_SUCCESS)
-                return VLC_EGENERIC;
-            break;
-        }
-        case DEMUX_SET_SEEKPOINT:
-        {
-            int i_chapter = (int)va_arg( args, int );
-            bd_seek_chapter( p_sys->bluray, i_chapter );
-            p_demux->info.i_update = INPUT_UPDATE_SEEKPOINT;
-            break;
-        }
-
-        case DEMUX_GET_TITLE_INFO:
-        {
-            input_title_t ***ppp_title = (input_title_t***)va_arg( args, input_title_t*** );
-            int *pi_int             = (int*)va_arg( args, int* );
-            int *pi_title_offset    = (int*)va_arg( args, int* );
-            int *pi_chapter_offset  = (int*)va_arg( args, int* );
+    case DEMUX_CAN_SEEK:
+    case DEMUX_CAN_PAUSE:
+    case DEMUX_CAN_CONTROL_PACE:
+        pb_bool = (bool*)va_arg( args, bool * );
+        *pb_bool = true;
+        break;
+
+    case DEMUX_GET_PTS_DELAY:
+        pi_64 = (int64_t*)va_arg( args, int64_t * );
+        *pi_64 =
+            INT64_C(1000) * var_InheritInteger( p_demux, "disc-caching" );
+        break;
+
+    case DEMUX_SET_PAUSE_STATE:
+        /* Nothing to do */
+        break;
+
+    case DEMUX_SET_TITLE: {
+        int i_title = (int)va_arg( args, int );
+        if (bluraySetTitle(p_demux, i_title) != VLC_SUCCESS)
+            return VLC_EGENERIC;
+        break;
+    }
+    case DEMUX_SET_SEEKPOINT: {
+        int i_chapter = (int)va_arg( args, int );
+        bd_seek_chapter( p_sys->bluray, i_chapter );
+        p_demux->info.i_update = INPUT_UPDATE_SEEKPOINT;
+        break;
+    }
 
-            /* */
-            *pi_title_offset   = 0;
-            *pi_chapter_offset = 0;
+    case DEMUX_GET_TITLE_INFO: {
+        input_title_t ***ppp_title = (input_title_t***)va_arg( args, input_title_t*** );
+        int *pi_int             = (int*)va_arg( args, int* );
+        int *pi_title_offset    = (int*)va_arg( args, int* );
+        int *pi_chapter_offset  = (int*)va_arg( args, int* );
 
-            /* Duplicate local title infos */
-            *pi_int = p_sys->i_title;
-            *ppp_title = calloc( p_sys->i_title, sizeof(input_title_t **) );
-            for( unsigned int i = 0; i < p_sys->i_title; i++ )
-                (*ppp_title)[i] = vlc_input_title_Duplicate( p_sys->pp_title[i]);
+        /* */
+        *pi_title_offset   = 0;
+        *pi_chapter_offset = 0;
 
-            return VLC_SUCCESS;
-        }
+        /* Duplicate local title infos */
+        *pi_int = p_sys->i_title;
+        *ppp_title = calloc( p_sys->i_title, sizeof(input_title_t **) );
+        for( unsigned int i = 0; i < p_sys->i_title; i++ )
+            (*ppp_title)[i] = vlc_input_title_Duplicate( p_sys->pp_title[i]);
 
-        case DEMUX_GET_LENGTH:
-        {
-            int64_t *pi_length = (int64_t*)va_arg(args, int64_t *);
-            *pi_length = CUR_LENGTH;
-            return VLC_SUCCESS;
-        }
-        case DEMUX_SET_TIME:
-        {
-            int64_t i_time = (int64_t)va_arg(args, int64_t);
-            bd_seek_time(p_sys->bluray, TO_TICKS(i_time));
-            return VLC_SUCCESS;
-        }
-        case DEMUX_GET_TIME:
-        {
-            int64_t *pi_time = (int64_t*)va_arg(args, int64_t *);
-            *pi_time = (int64_t)FROM_TICKS(bd_tell_time(p_sys->bluray));
-            return VLC_SUCCESS;
-        }
+        return VLC_SUCCESS;
+    }
 
-        case DEMUX_GET_POSITION:
-        {
-            double *pf_position = (double*)va_arg( args, double * );
-            *pf_position = (double)FROM_TICKS(bd_tell_time(p_sys->bluray))/CUR_LENGTH;
-            return VLC_SUCCESS;
-        }
-        case DEMUX_SET_POSITION:
-        {
-            double f_position = (double)va_arg(args, double);
-            bd_seek_time(p_sys->bluray, TO_TICKS(f_position*CUR_LENGTH));
-            return VLC_SUCCESS;
-        }
+    case DEMUX_GET_LENGTH: {
+        int64_t *pi_length = (int64_t*)va_arg(args, int64_t *);
+        *pi_length = CUR_LENGTH;
+        return VLC_SUCCESS;
+    }
+    case DEMUX_SET_TIME: {
+        int64_t i_time = (int64_t)va_arg(args, int64_t);
+        bd_seek_time(p_sys->bluray, TO_TICKS(i_time));
+        return VLC_SUCCESS;
+    }
+    case DEMUX_GET_TIME: {
+        int64_t *pi_time = (int64_t*)va_arg(args, int64_t *);
+        *pi_time = (int64_t)FROM_TICKS(bd_tell_time(p_sys->bluray));
+        return VLC_SUCCESS;
+    }
 
-        case DEMUX_GET_META:
-        {
-            vlc_meta_t *p_meta = (vlc_meta_t *) va_arg (args, vlc_meta_t*);
-            const META_DL   *meta = p_sys->p_meta;
+    case DEMUX_GET_POSITION: {
+        double *pf_position = (double*)va_arg( args, double * );
+        *pf_position = (double)FROM_TICKS(bd_tell_time(p_sys->bluray))/CUR_LENGTH;
+        return VLC_SUCCESS;
+    }
+    case DEMUX_SET_POSITION: {
+        double f_position = (double)va_arg(args, double);
+        bd_seek_time(p_sys->bluray, TO_TICKS(f_position*CUR_LENGTH));
+        return VLC_SUCCESS;
+    }
 
-            if (!EMPTY_STR(meta->di_name)) vlc_meta_SetTitle(p_meta, meta->di_name);
+    case DEMUX_GET_META: {
+        vlc_meta_t *p_meta = (vlc_meta_t *) va_arg (args, vlc_meta_t*);
+        const META_DL   *meta = p_sys->p_meta;
 
-            if (!EMPTY_STR(meta->language_code)) vlc_meta_AddExtra(p_meta, "Language", meta->language_code);
-            if (!EMPTY_STR(meta->filename)) vlc_meta_AddExtra(p_meta, "Filename", meta->filename);
-            if (!EMPTY_STR(meta->di_alternative)) vlc_meta_AddExtra(p_meta, "Alternative", meta->di_alternative);
+        if (!EMPTY_STR(meta->di_name)) vlc_meta_SetTitle(p_meta, meta->di_name);
 
-            // if (meta->di_set_number > 0) vlc_meta_SetTrackNum(p_meta, meta->di_set_number);
-            // if (meta->di_num_sets > 0) vlc_meta_AddExtra(p_meta, "Discs numbers in Set", meta->di_num_sets);
+        if (!EMPTY_STR(meta->language_code)) vlc_meta_AddExtra(p_meta, "Language", meta->language_code);
+        if (!EMPTY_STR(meta->filename)) vlc_meta_AddExtra(p_meta, "Filename", meta->filename);
+        if (!EMPTY_STR(meta->di_alternative)) vlc_meta_AddExtra(p_meta, "Alternative", meta->di_alternative);
 
-            if (meta->thumb_count > 0 && meta->thumbnails) {
-                vlc_meta_SetArtURL(p_meta, meta->thumbnails[0].path);
-            }
+        // if (meta->di_set_number > 0) vlc_meta_SetTrackNum(p_meta, meta->di_set_number);
+        // if (meta->di_num_sets > 0) vlc_meta_AddExtra(p_meta, "Discs numbers in Set", meta->di_num_sets);
 
-            return VLC_SUCCESS;
+        if (meta->thumb_count > 0 && meta->thumbnails) {
+            vlc_meta_SetArtURL(p_meta, meta->thumbnails[0].path);
         }
 
-        case DEMUX_CAN_RECORD:
-        case DEMUX_GET_FPS:
-        case DEMUX_SET_GROUP:
-        case DEMUX_HAS_UNSUPPORTED_META:
-        case DEMUX_GET_ATTACHMENTS:
-            return VLC_EGENERIC;
-        default:
-            msg_Warn( p_demux, "unimplemented query (%d) in control", query );
-            return VLC_EGENERIC;
+        return VLC_SUCCESS;
+    }
+
+    case DEMUX_CAN_RECORD:
+    case DEMUX_GET_FPS:
+    case DEMUX_SET_GROUP:
+    case DEMUX_HAS_UNSUPPORTED_META:
+    case DEMUX_GET_ATTACHMENTS:
+        return VLC_EGENERIC;
+    default:
+        msg_Warn( p_demux, "unimplemented query (%d) in control", query );
+        return VLC_EGENERIC;
     }
     return VLC_SUCCESS;
 }
 
 static void     blurayHandleEvent( demux_t *p_demux, const BD_EVENT *e )
 {
-    demux_sys_t *p_sys = p_demux->p_sys;
-
-    switch( e->event )
-    {
-        case BD_EVENT_TITLE:
-            blurayUpdateTitle( p_demux, e->param );
-            break ;
-        case BD_EVENT_PLAYITEM:
-            break ;
-        case BD_EVENT_AUDIO_STREAM:
-            break ;
-        case BD_EVENT_CHAPTER:
-            p_demux->info.i_update |= INPUT_UPDATE_SEEKPOINT;
-            p_demux->info.i_seekpoint = 0;
-            break ;
-        case BD_EVENT_ANGLE:
-        case BD_EVENT_IG_STREAM:
-        default:
-            msg_Warn( p_demux, "event: %d param: %d", e->event, e->param );
-            break ;
+    switch( e->event ) {
+    case BD_EVENT_TITLE:
+        blurayUpdateTitle( p_demux, e->param );
+        break ;
+    case BD_EVENT_PLAYITEM:
+        break ;
+    case BD_EVENT_AUDIO_STREAM:
+        break ;
+    case BD_EVENT_CHAPTER:
+        p_demux->info.i_update |= INPUT_UPDATE_SEEKPOINT;
+        p_demux->info.i_seekpoint = 0;
+        break ;
+    case BD_EVENT_ANGLE:
+    case BD_EVENT_IG_STREAM:
+    default:
+        msg_Warn( p_demux, "event: %d param: %d", e->event, e->param );
+        break ;
     }
 }
 
@@ -985,8 +742,7 @@ static void    blurayHandleEvents( demux_t *p_demux )
 {
     BD_EVENT    e;
 
-    while ( bd_get_event( p_demux->p_sys->bluray, &e ) )
-    {
+    while ( bd_get_event( p_demux->p_sys->bluray, &e ) ) {
         blurayHandleEvent( p_demux, &e );
     }
 }
@@ -1006,13 +762,12 @@ static int blurayDemux(demux_t *p_demux)
     if ( p_sys->b_menu == false ) {
         blurayHandleEvents( p_demux );
         nread = bd_read(p_sys->bluray, p_block->p_buffer,
-                            NB_TS_PACKETS * BD_TS_PACKET_SIZE);
+                        NB_TS_PACKETS * BD_TS_PACKET_SIZE);
         if (nread < 0) {
             block_Release(p_block);
             return nread;
         }
-    }
-    else {
+    } else {
         BD_EVENT e;
         nread = bd_read_ext( p_sys->bluray, p_block->p_buffer,
                              NB_TS_PACKETS * BD_TS_PACKET_SIZE, &e );
@@ -1036,8 +791,7 @@ static int blurayDemux(demux_t *p_demux)
                     var_AddCallback( p_sys->p_vout, "mouse-clicked", &onMouseEvent, p_demux );
                     bluraySendOverlayToVout( p_demux );
                 }
-            }
-            else
+            } else
                 vlc_mutex_unlock( &p_sys->p_overlays[p_sys->current_overlay]->lock );
         }
     }
@@ -1045,3 +799,200 @@ static int blurayDemux(demux_t *p_demux)
     stream_DemuxSend( p_sys->p_parser, p_block );
     return 1;
 }
+
+/*****************************************************************************
+ * blurayOpen: module init function
+ *****************************************************************************/
+static int blurayOpen( vlc_object_t *object )
+{
+    demux_t *p_demux = (demux_t*)object;
+    demux_sys_t *p_sys;
+
+    char *pos_title;
+    int i_title = -1;
+    char bd_path[PATH_MAX] = { '\0' };
+    const char *error_msg = NULL;
+
+    if (strcmp(p_demux->psz_access, "bluray")) {
+        // TODO BDMV support, once we figure out what to do in libbluray
+        return VLC_EGENERIC;
+    }
+
+    /* */
+    p_demux->p_sys = p_sys = calloc( 1, sizeof(*p_sys) );
+    if (unlikely(!p_sys)) {
+        return VLC_ENOMEM;
+    }
+    p_sys->current_overlay = -1;
+
+    /* init demux info fields */
+    p_demux->info.i_update    = 0;
+    p_demux->info.i_title     = 0;
+    p_demux->info.i_seekpoint = 0;
+
+    TAB_INIT( p_sys->i_title, p_sys->pp_title );
+
+    /* store current bd_path */
+    if (p_demux->psz_file) {
+        strncpy(bd_path, p_demux->psz_file, sizeof(bd_path));
+        bd_path[PATH_MAX - 1] = '\0';
+    }
+
+#if defined (HAVE_MNTENT_H) && defined (HAVE_SYS_STAT_H)
+    /* If we're passed a block device, try to convert it to the mount point. */
+    struct stat st;
+    if ( !stat (bd_path, &st)) {
+        if (S_ISBLK (st.st_mode)) {
+            FILE* mtab = setmntent ("/proc/self/mounts", "r");
+            struct mntent* m;
+            struct mntent mbuf;
+            char buf [8192];
+            while ((m = getmntent_r (mtab, &mbuf, buf, sizeof(buf))) != NULL) {
+                if (!strcmp (m->mnt_fsname, bd_path)) {
+                    strncpy (bd_path, m->mnt_dir, sizeof(bd_path));
+                    bd_path[sizeof(bd_path) - 1] = '\0';
+                    break;
+                }
+            }
+            endmntent (mtab);
+        }
+    }
+#endif /* HAVE_MNTENT_H && HAVE_SYS_STAT_H */
+    p_sys->bluray = bd_open(bd_path, NULL);
+    if (!p_sys->bluray) {
+        free(p_sys);
+        return VLC_EGENERIC;
+    }
+
+    /* Warning the user about AACS/BD+ */
+    const BLURAY_DISC_INFO *disc_info = bd_get_disc_info(p_sys->bluray);
+    if ( disc_info->bluray_detected == 0 ) {
+        error_msg = "Path doesn't appear to be a bluray";
+        goto error;
+    }
+    msg_Info(p_demux, "First play: %i, Top menu: %i\n"
+             "HDMV Titles: %i, BD-J Titles: %i, Other: %i",
+             disc_info->first_play_supported, disc_info->top_menu_supported,
+             disc_info->num_hdmv_titles, disc_info->num_bdj_titles,
+             disc_info->num_unsupported_titles);
+
+    /* AACS */
+    if (disc_info->aacs_detected) {
+        if (!disc_info->libaacs_detected) {
+            error_msg = _("This Blu-Ray Disc needs a library for AACS decoding, "
+                          "and your system does not have it.");
+            goto error;
+        }
+        if (!disc_info->aacs_handled) {
+            error_msg = _("Your system AACS decoding library does not work. "
+                          "Missing keys?");
+            goto error;
+        }
+    }
+
+    /* BD+ */
+    if (disc_info->bdplus_detected) {
+        if (!disc_info->libbdplus_detected) {
+            error_msg = _("This Blu-Ray Disc needs a library for BD+ decoding, "
+                          "and your system does not have it.");
+            goto error;
+        }
+        if (!disc_info->bdplus_handled) {
+            error_msg = _("Your system BD+ decoding library does not work. "
+                          "Missing configuration?");
+            goto error;
+        }
+    }
+
+    /* Get titles and chapters */
+    p_sys->p_meta = bd_get_meta( p_sys->bluray );
+    if( p_sys->p_meta == NULL )
+        goto error;
+
+    if (blurayInitTitles(p_demux) != VLC_SUCCESS) {
+        goto error;
+    }
+
+    /*
+     * Initialize the event queue, so we can receive then in blurayDemux(Menu) later.
+     */
+    bd_get_event( p_sys->bluray, NULL );
+
+    p_sys->b_menu = var_InheritBool( p_demux, "bluray-menu" );
+    if ( p_sys->b_menu ) {
+        p_sys->p_input = demux_GetParentInput( p_demux );
+        if ( unlikely( p_sys->p_input == NULL ) )
+            goto error;
+        /*
+         * libbluray will start playback from "First-Title" title
+         * Therefore, We don't have to select any title.
+         */
+        bd_play( p_sys->bluray );
+        /* Registering overlay event handler */
+        bd_register_overlay_proc( p_sys->bluray, p_demux, blurayOverlayProc );
+    } else {
+        /* get title request */
+        if ((pos_title = strrchr(bd_path, ':'))) {
+            /* found character ':' for title information */
+            *(pos_title++) = '\0';
+            i_title = atoi(pos_title);
+        }
+
+        /* set start title number */
+        if (bluraySetTitle(p_demux, i_title) != VLC_SUCCESS) {
+            msg_Err( p_demux, "Could not set the title %d", i_title );
+            goto error;
+        }
+    }
+
+    p_sys->p_parser   = stream_DemuxNew(p_demux, "ts", p_demux->out);
+    if (!p_sys->p_parser) {
+        msg_Err(p_demux, "Failed to create TS demuxer");
+        goto error;
+    }
+
+    p_demux->pf_control = blurayControl;
+    p_demux->pf_demux   = blurayDemux;
+
+    return VLC_SUCCESS;
+
+error:
+    if (error_msg)
+        dialog_Fatal(p_demux, _("Blu-Ray error"), "%s", error_msg);
+    blurayClose(object);
+    return VLC_EGENERIC;
+}
+
+
+/*****************************************************************************
+ * blurayClose: module destroy function
+ *****************************************************************************/
+static void blurayClose( vlc_object_t *object )
+{
+    demux_t *p_demux = (demux_t*)object;
+    demux_sys_t *p_sys = p_demux->p_sys;
+
+    /*
+     * Close libbluray first. This will close all the overlays before we release p_vout
+     *
+     * bd_close( NULL ) can crash
+     */
+    assert(p_sys->bluray);
+    bd_close(p_sys->bluray);
+
+    if ( p_sys->p_vout != NULL ) {
+        var_DelCallback( p_sys->p_vout, "mouse-moved", &onMouseEvent, p_demux );
+        var_DelCallback( p_sys->p_vout, "mouse-clicked", &onMouseEvent, p_demux );
+        vlc_object_release( p_sys->p_vout );
+    }
+    if ( p_sys->p_input != NULL )
+        vlc_object_release( p_sys->p_input );
+    if (p_sys->p_parser)
+        stream_Delete(p_sys->p_parser);
+    /* Titles */
+    for (unsigned int i = 0; i < p_sys->i_title; i++)
+        vlc_input_title_Delete(p_sys->pp_title[i]);
+    TAB_CLEAN( p_sys->i_title, p_sys->pp_title );
+
+    free(p_sys);
+}
-- 
1.7.9.2

